import time
import sys
#
if not Misc.CurrentScriptDirectory() in sys.path:
    sys.path.append(Misc.CurrentScriptDirectory())

import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
from System import Byte, Int32
#
#
#                        
def provoke(enemy1, enemy2):
    Target.ClearLastandQueue()
    now = time.time()
    Journal.Clear()    
    Player.UseSkill('Provocation') 
    journal_msg = ""
    limit = time.time() + 1
    while time.time() < limit:
        if Journal.Search("Whom do you wish"):
            journal_msg = "Whom do you wish"
            limit = 0  # force out of loop
        if Journal.Search("shall you play"):
            journal_msg = "shall you play"
            limit = 0  # force out of loop
    if journal_msg == "":
        Misc.SendMessage("No msg from wait loop?")
        Target.Cancel()
        return # wtf ?
    if journal_msg == "shall you play":
        instrumentID = 0xe9c
        drum = Items.FindByID(instrumentID, -1, Player.Backpack.Serial)
        if drum == None:
            return
        Target.WaitForTarget(500)
        Target.TargetExecute(drum)
        Misc.Pause(100)
    Journal.WaitJournal("Whom do you wish", 5000)    
    #Target.WaitForTarget(10000)
    Misc.SendMessage("Enemy Targets: 0x{:x} -> 0x{:x}".format(enemy1, enemy2))
    Target.TargetExecute(enemy1)
    Misc.Pause(500)
    Target.WaitForTarget(1500)
    Target.TargetExecute(enemy2)
    Misc.Pause(500)
    #Target.Cancel()
    return
    
    
while True: 
    instrumentID = 0xe9c
    drum = Items.FindByID(instrumentID, -1, Player.Backpack.Serial)
    if drum == None:
        break   
    #
    if Player.Visible:
        Misc.IgnoreObject(Player.Serial)
        enemy_filter = Mobiles.Filter()
        enemy_filter.Enabled = True
        enemy_filter.RangeMin = -1
        enemy_filter.RangeMax = 10
        enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
        enemies = Mobiles.ApplyFilter(enemy_filter)
        if len(enemies) >= 2:
            #provoke(enemies[0].Serial, enemies[1].Serial)
            enemy1 = Mobiles.Select(enemies, "Nearest")    
            #del (enemies, enemy1)
            enemies.Remove(enemy1)
            enemy2 = Mobiles.Select(enemies, "Nearest")
            provoke(enemy1.Serial, enemy2.Serial)
            for i in range(12, 1, -1):
                Player.HeadMessage(5, "{}".format(i))
                Misc.Pause(1000)
        else:
            Misc.SendMessage("Not enough monster {}".format(len(enemies)))
            Misc.Pause(1000)
    else:        
        Misc.Pause(1000)